/**
 * Neu: Das Barabasi Netzwerkmodel
 * Java-Applet Vorlage mit einem Thread
 * Eingabefeld, Start- und Stop-Button, 
 * Thread fuer die Animation,
 * String Ausgabe der Laufzaehlers des Thread
 * String Ausgabe des vom Benutzer eingegebenen Wertes
 * Viel Spass 
 * Matthias Hanauske, hanauske@wiwi.uni-frankfurt.de
 * 
 * Bitte Veraenderungen mit Komentaren versehen
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Random;
import java.lang.Object;

public class Netzwerk3 extends JApplet implements Runnable{
   //ButtonsLabelsundEingabefelder
   int anz_eingabe=4;
   JButton button1,button2;
   JLabel[] lb = new JLabel[anz_eingabe+1];
   JTextField[]  jinput = new JTextField[anz_eingabe+1];
   String[] eingabe ={"null","Axenstreckung","Anz. Kanten pro it","Anz. Knoten pro it","AnfangsAttr."};
   String[] eingabewert = {"null","200","1","1","1"}; 
   //LaufzaelerFuerThread
   int t=1;
   //ThreadAnAus
   boolean thr=false; 
   //Eingabevariablen
   double[] input = new double[20];
   //Netzwerkvariablen
   int M=1;//AnzahlAutoren
   int z=1;//AnzahlLinks
   int k0=1;//Anfangszitate
   int t0=t;//AnfangsZeit
   int N0=M*t0;//AnfangsArtikel
   int Z0=z*M*t0;//AnfangsZitate
   int l=1,maxN=1,maxk=1;
   int a=1,m=1;
   //Links
   boolean[][] S = new boolean[5000][5000];  
   int[] K = new int[5000];
   int Z_anz=1;
   //ZufallsZahlen
   Random zufall = new Random();
   GammaFunction gammaf = new GammaFunction();
   int zuf,zufk,zufkl; 
   //Plotten
   int y_max=1;
   // Konstruktor der Hauptklasse
   public Netzwerk3() {
      System.out.println("Konstruktor");   
   }
   public void init() {
      System.out.println("init()");
      S[2][1]=true;
      S[1][2]=true;
      getContentPane().add(new ContentPane());
   }   
   public void start() {
      System.out.println("start()"); 
   }
   class ContentPane extends JPanel { 	   
     //Konstruktor der Klasse ContentPane  
      public ContentPane() {
    	  System.out.println("ContentPane()"); 
          setLayout(null); 
          Initialisierungspanel();
      }
      //Initialisierungspanel
      public void Initialisierungspanel(){  
         //Button1	 	 
         button1 = new JButton();
         button1.setBounds(new Rectangle(500,45,100,40));
         button1.setText("Start");
         add(button1);	 
         button1.addActionListener(new ActionListener() {
        	 public void actionPerformed(ActionEvent e) {
        		 System.out.println("button1 gedrueckt");  
        		 startAnimation();        	       	       	
        	 }});
         //Button2
         button2 = new JButton();
         button2.setBounds(new Rectangle(500,100,100,40));
         button2.setText("Stop");
         add(button2);	 
         button2.addActionListener(new ActionListener() {
        	 public void actionPerformed(ActionEvent e) {
        		 System.out.println("button2 gedrueckt");        
        		 thr=false;
        	 }});
         //EingabeFelder
         int init_y=150;
         int n=1;
	 while(init_y<=420 & n<=anz_eingabe){
				init_y=init_y+25;
				lb[n] = new JLabel(eingabe[n]);
				lb[n].setBounds(475,init_y, 170, 20);
				add(lb[n]);
				init_y=init_y+20;
				jinput[n]     = new JTextField();
				jinput[n].setBounds(new Rectangle(475,init_y,150,20));
				jinput[n].setText(eingabewert[n]);
				add(jinput[n]);
				n++;
			}	 
      }
      //DarstellungsmethodePaint
      public void paintComponent(Graphics g) 
      {
    	  super.paintComponent(g);
    	  System.out.println("paintComponent()");	
    	  setBackground(Color.white); 
          g.drawString("Thread counter it = "+t,480,20);
          zeichneknoten(200,(int)(input[1]),t,6,g);
          zeichnenetz(200,(int)(input[1]),t,z,S,g);
          y_max=Math.max(maxN+2,(int)(z*M*t*P_Doro(0,1,1)+2));
          for(int i=0;i<=maxk+2;++i){
                   if(N(i,t,z,S)!=0){maxk=Math.max(maxk,i);maxN=Math.max(maxN,N(i,t,z,S));}
                   g.drawString("N("+i+") = "+N(i,t,z,S),680,20*(i+1));
                   g.drawString("log(N("+i+")) = "+Math.log(N(i,t,z,S)),800,20*(i+1));
                   PunktPlotnew(1000,450,200,150,0,Math.log(maxk+2),0,Math.log(maxN+2),"ln(N(ln(k)))",7,Color.blue,g,Math.log(i+1),Math.log(N(i,t,z,S)));
                   PunktPlotnew(750,450,200,150,0,maxk+2,0,Math.log(maxN+2),"ln(N(k))",7,Color.blue,g,i,Math.log(N(i,t,z,S)));
                   PunktPlotnew(500,450,200,150,0,maxk+2,0,maxN+2,"N(k)",7,Color.blue,g,i,N(i,t,z,S));

//                   PunktPlotnew(1000,650,200,150,0,Math.log(maxk+2),0,Math.log(z*M*t*P_Doro(0,1,1)+2),"ln(N(ln(k)))",7,Color.red,g,Math.log(i+1),Math.log(z*M*t*P_Doro(i,1,1)));
//               PunktPlotnew(750,650,200,150,0,maxk+2,0,Math.log(z*M*t*P_Doro(0,1,1)+2),"ln(N(k))",7,Color.red,g,i,Math.log(z*M*t*P_Doro(i,1,1)));
//               PunktPlotnew(500,650,200,150,0,maxk+2,0,z*M*t*P_Doro(0,1,1)+2,"N(k)",7,Color.red,g,i,z*M*t*P_Doro(i,1,1));
                PunktPlotnew(1000,650,200,150,0,Math.log(maxk+2),0,Math.log(y_max),"ln(N(ln(k)))",7,Color.blue,g,Math.log(i+1),Math.log(N(i,t,z,S)));
                   PunktPlotnew(750,650,200,150,0,maxk+2,0,Math.log(y_max),"ln(N(k))",7,Color.blue,g,i,Math.log(N(i,t,z,S)));
                   PunktPlotnew(500,650,200,150,0,maxk+2,0,y_max,"N(k)",7,Color.blue,g,i,N(i,t,z,S));
//                   PunktPlotnew(1000,650,200,150,0,Math.log(maxk+2),0,Math.log(z*M*t*P_Doro(0,1,1)+2),"ln(N(ln(k)))",7,Color.green,g,Math.log(i+1),Math.log(z*M*t*P_Dorot(i,1,1,t)));
//               PunktPlotnew(750,650,200,150,0,maxk+2,0,Math.log(z*M*t*P_Doro(0,1,1)+2),"ln(N(k))",7,Color.green,g,i,Math.log(z*M*t*P_Dorot(i,1,1,t)));
//               PunktPlotnew(500,650,200,150,0,maxk+2,0,z*M*t*P_Doro(0,1,1)+2,"N(k)",7,Color.green,g,i,z*M*t*P_Dorot(i,1,1,t));
PunktPlotnew(1000,650,200,150,0,Math.log(maxk+2),0,Math.log(z*M*t*P_Doro(0,1,1)+2),"ln(N(ln(k)))",7,Color.red,g,Math.log(i+1),Math.log(z*M*t*P_cites(i,z,M,k0)));
               PunktPlotnew(750,650,200,150,0,maxk+2,0,Math.log(z*M*t*P_Doro(0,1,1)+2),"ln(N(k))",7,Color.red,g,i,Math.log(z*M*t*P_cites(i,z,M,k0)));
               PunktPlotnew(500,650,200,150,0,maxk+2,0,z*M*t*P_Doro(0,1,1)+2,"N(k)",7,Color.red,g,i,z*M*t*P_cites(i,z,M,k0));
          }	  
      }
   }
   //AnimationundThreadstarten
   public void startAnimation(){
	   t=1;
	   thr=true;
	   Thread th = new Thread(this);
	   th.start();
	   th.setPriority(Thread.MAX_PRIORITY);	   
   }
   //runMethodedesThreads
   public void run(){
	   System.out.println("run Methode des Threads gestartet.");  
	   while (thr==true)
	   { 
                   try{
                          for(int i=1;i<=anz_eingabe;++i){
                                   input[i]= Double.valueOf(jinput[i].getText()).doubleValue(); 
        		   }
                   }catch(NumberFormatException e){}
                   z=(int)(input[2]);
                   M=(int)(input[3]);
                   k0=(int)(input[4]);
                   t++; 
                   l=1;
                   for(int i=0;i<=t;++i){ 
                            K[i]=K(i,t,S);
//                            System.out.println("K["+i+"] = "+K[i]);
                   }
                   while(l<=z){                           
                            zufk=zufall.nextInt(z*M*t)+1;
//                            System.out.println("zufk = "+zufk+" , z*M*t = "+(z*M*t));
                            zufkl=0;
                            zuf=0;
                            for(int i=1;i<=M*t;++i){
                                     zufkl=zufkl+K[i]; 
//                                     System.out.println("K["+i+"] = "+K[i]);
//                                     System.out.println("zufkl = "+zufkl);                                    
                                     if(zufkl>=zufk && zuf==0){zuf=zufk;}
                            }
//                            System.out.println("Zufall ----------- "+zuf);
                            if((S[t][zuf]==false || t==2) && zuf!=t && zuf!=0){S[t][zuf]=true;l=l+1;}                           
                   }
		   repaint(); 
		   try{
			   Thread.sleep(30);
		   }catch(InterruptedException e){}
	   }
   } 
   //StoppenUndZerstoerenDesApplets
   public void stop() {
	      System.out.println("stop()");
	   }
	  public void destroy() {
	      System.out.println("destroy()");
	   }
   //Zeichnen der Knoten des Netzes
   public void zeichneknoten(int dx, int dy, int anz_knoten, double radius, Graphics gra){
	   if(radius==0){radius=10;}  
	   double angle;
	   for(int i=1;i<=anz_knoten;++i){
		   angle=2*Math.PI*(i-1)/(anz_knoten);
		   gra.drawOval((int)(dx+dx*Math.cos(angle))+20,(int)(dy+dy*Math.sin(angle))+20,(int)(radius),(int)(radius));
		   gra.drawString(""+i,(int)(dx+dx*Math.cos(angle)+radius/8)+15,(int)(dy+dy*Math.sin(angle)+3*radius/8)+15);
	   } 
   }
  //Zeichnen aller Knoten-Verbindungslinien (mehrere ausgehende links, über S[][]-matrix) 
   public void zeichnenetz(int dx, int dy, int anz_knoten, int anz_links, boolean[][] S, Graphics gra){ 
	   double angle,angle1;
	   for(int i=1;i<=anz_knoten;++i){
		   angle=2*Math.PI*(i-1)/(anz_knoten);
		   for(int j=1;j<=anz_knoten;++j)
		   {
//                           System.out.println("Knoten "+i+" zitiert "+j+": "+S[i][j]);
			   if(S[i][j]==true){angle1=2*Math.PI*(j-1)/(anz_knoten);
				    gra.drawLine((int)(dx+dx*Math.cos(angle))+20,(int)(dy+dy*Math.sin(angle))+20,(int)(dx+dx*Math.cos(angle1))+20,(int)(dy+dy*Math.sin(angle1))+20);
                                    }		
		   }
	   }
   }
  //Definition der kulminierten Verteilungsfunktion (N(k):=(Anzahl der Knoten)(mit k eingehenden Links), mehrere ausgehende links pro Knoten und S[][]-Matrix)
   public int N(int k, int anz_knoten, int anz_links, boolean[][] S){
           int Anz_N=0;
           int[] Anz_Links = new int[anz_knoten+1];
           for(int s=1;s<=anz_knoten;++s){
	            for(int i=1;i<=anz_knoten;++i){
                         if(S[i][s]==true){ 
                              Anz_Links[s]=Anz_Links[s]+1;
//                              System.out.println("S["+s+","+i+"] = "+S[s][i]);
                         } 
                    }        
           }
           for(int s=1;s<=anz_knoten;++s){
                   if(Anz_Links[s]==k){ 
                      Anz_N=Anz_N+1;        
                   } 
           }
           return Anz_N; 
   }
  //KnotendegreeK[s]
   public int K(int s, int anz_knoten, boolean[][] S){
           int NK=0;
	   for(int i=1;i<=anz_knoten;++i){
                    if(S[i][s]==true){ 
                            NK=NK+1;
                    }         
           }  
           return NK; 
   }
   //Funktionsplotter
	public void PunktPlotnew(int ursprx_panel, int urspry_panel, int panelbreite, int panelh, double minx, double maxx,double miny, double maxy, String beschr, int radius, Color farbe, Graphics g,double x,double y) {
		g.drawRect(ursprx_panel,urspry_panel,panelbreite,panelh);
		g.setFont(new Font("Georgia",Font.ITALIC,15));
		g.setColor(Color.black);
		g.drawString(beschr,(int)(ursprx_panel+panelbreite/3),urspry_panel-2);
		g.setFont(new Font("Georgia",Font.ITALIC,12));
		g.drawString("("+(float)(Math.round(1000*minx)*0.001)+","+(float)(Math.round(1000*maxy)*0.001)+")",ursprx_panel-5,urspry_panel-2);
		g.drawString("("+(float)(Math.round(1000*minx)*0.001)+","+(float)(Math.round(1000*miny)*0.001)+")",ursprx_panel-5,urspry_panel+panelh+10);
		g.drawString("("+(float)(Math.round(1000*maxx)*0.001)+","+(float)(Math.round(1000*maxy)*0.001)+")",ursprx_panel-60+panelbreite,urspry_panel-2);
		g.drawString("("+(float)(Math.round(1000*maxx)*0.001)+","+(float)(Math.round(1000*miny)*0.001)+")",ursprx_panel-60+panelbreite,urspry_panel+panelh+10);
		g.setColor(farbe);
		if(x<=maxx && x>=minx && y<=maxy && y>=miny){
			panelh=panelh-radius;
			g.fillOval((int)(ursprx_panel-minx*panelbreite/(maxx-minx)+x*panelbreite/(maxx-minx)),(int)(urspry_panel+panelh+miny*panelh/(maxy-miny) -y*panelh/(maxy-miny)),radius,radius);
		}
		g.setColor(Color.black);
	}
     //VerteilungsfunktionP(k,a,m)PRLDoro
    public double P_Doro(int k,int a,int m){
                       double P=0;
                       P=((a+1)*Math.exp(gammaf.lnGamma(a*(m+1)+1))*Math.exp(gammaf.lnGamma(a*m+k)))/(Math.exp(gammaf.lnGamma(a*m))*Math.exp(gammaf.lnGamma(k+2+a*(m+1))));
                       //System.out.println("P = "+P);
                       return P;                   
    }
     //Verteilungsfunktion p(k,a,m,t)PRLDoro
    public double p_Doro_neu(int k,int a,int m,int t,int s){
                       double p=0;
                       p=(Math.exp(gammaf.lnGamma(a*m+k)))/(Math.exp(gammaf.lnGamma(a*m))*Fakultaet(k))*Math.pow((s/t),(a*m)/(double)((1+a)))*Math.pow((1-Math.pow((s/t),(1/(double)((1+a))))),k);
                           
//                       System.out.println("--------- P = "+P_all);
                       return p;                   
    }
     //VerteilungsfunktionP(k,a,m,t)PRLDoro
    public double P_Dorot(int k,int a,int m,int t){
//                       System.out.println("t = "+t+" k = "+k);
                       double P_all=0;
                       double p=0;
                       for(double s=1;s<=m*t;s++){
                           p=(Math.exp(gammaf.lnGamma(a*m+k)))/(Math.exp(gammaf.lnGamma(a*m))*Fakultaet(k))*Math.pow((s/t),(a*m)/(double)((1+a)))*Math.pow((1-Math.pow((s/t),(1/(double)((1+a))))),k);
                           P_all=P_all+p;
//                           System.out.println("P = "+P_all+" p = "+p+" (s/t) = "+Math.pow((s/t),(a*m)/((double)(a+1))));
                           }
                       P_all=P_all/(1+m*t);
//                       System.out.println("--------- P = "+P_all);
                       return P_all;                   
    }
     //VerteilungsfunktionP(k,z,M,k0)PRLDoro
    public double P_cites(int k,int z,int M,int k0){
                       double P=0;
                       double a,m;
                       m=M*z;
                       a=k0/m;
                       P=((a+1)*Math.exp(gammaf.lnGamma(a*(m+1)+1))*Math.exp(gammaf.lnGamma(a*m+k)))/(Math.exp(gammaf.lnGamma(a*m))*Math.exp(gammaf.lnGamma(k+2+a*(m+1))));
                       //System.out.println("P = "+P);
                       return P;                   
    }
    //Fakultaet
    public double Fakultaet(int q){
                       int Fak=1;
                       for(int i=1;i<=q;i++){Fak=Fak*i;}
                       return Fak;                   
    }
}
